
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExamsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exams = await db.exams.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        exam_type: data.exam_type
        ||
        null
            ,
            
        starts_at: data.starts_at
        ||
        null
            ,
            
        ends_at: data.ends_at
        ||
        null
            ,
            
        public_results: data.public_results
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await exams.setSchool_year( data.school_year || null, {
            transaction,
        });
        
        await exams.setTerm( data.term || null, {
            transaction,
        });
        
        await exams.setGrade( data.grade || null, {
            transaction,
        });
        
        await exams.setStream( data.stream || null, {
            transaction,
        });
        

        

        

        return exams;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const examsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                exam_type: item.exam_type
            ||
            null
            ,
            
                starts_at: item.starts_at
            ||
            null
            ,
            
                ends_at: item.ends_at
            ||
            null
            ,
            
                public_results: item.public_results
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const exams = await db.exams.bulkCreate(examsData, { transaction });

        // For each item created, replace relation files
        

        return exams;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const exams = await db.exams.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.exam_type !== undefined) updatePayload.exam_type = data.exam_type;
        
        
        if (data.starts_at !== undefined) updatePayload.starts_at = data.starts_at;
        
        
        if (data.ends_at !== undefined) updatePayload.ends_at = data.ends_at;
        
        
        if (data.public_results !== undefined) updatePayload.public_results = data.public_results;
        
        
        updatePayload.updatedById = currentUser.id;

        await exams.update(updatePayload, {transaction});

        
        
        if (data.school_year !== undefined) {
            await exams.setSchool_year(
              
              data.school_year,
              
              { transaction }
            );
        }
        
        if (data.term !== undefined) {
            await exams.setTerm(
              
              data.term,
              
              { transaction }
            );
        }
        
        if (data.grade !== undefined) {
            await exams.setGrade(
              
              data.grade,
              
              { transaction }
            );
        }
        
        if (data.stream !== undefined) {
            await exams.setStream(
              
              data.stream,
              
              { transaction }
            );
        }
        

        
        

        

        return exams;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exams = await db.exams.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of exams) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of exams) {
                await record.destroy({transaction});
            }
        });


        return exams;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const exams = await db.exams.findByPk(id, options);

        await exams.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await exams.destroy({
            transaction
        });

        return exams;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const exams = await db.exams.findOne(
            { where },
            { transaction },
        );

        if (!exams) {
            return exams;
        }

        const output = exams.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.exam_results_exam = await exams.getExam_results_exam({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.exam_performance_summaries_exam = await exams.getExam_performance_summaries_exam({
            transaction
        });
        
        
        output.top_student_features_exam = await exams.getTop_student_features_exam({
            transaction
        });
        
        
        
        output.school_year = await exams.getSchool_year({
            transaction
        });
        
        
        output.term = await exams.getTerm({
            transaction
        });
        
        
        output.grade = await exams.getGrade({
            transaction
        });
        
        
        output.stream = await exams.getStream({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.school_years,
        as: 'school_year',
        
        where: filter.school_year ? {
          [Op.or]: [
            { id: { [Op.in]: filter.school_year.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.school_year.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.terms,
        as: 'term',
        
        where: filter.term ? {
          [Op.or]: [
            { id: { [Op.in]: filter.term.split('|').map(term => Utils.uuid(term)) } },
            {
              term_name: {
                [Op.or]: filter.term.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.grades,
        as: 'grade',
        
        where: filter.grade ? {
          [Op.or]: [
            { id: { [Op.in]: filter.grade.split('|').map(term => Utils.uuid(term)) } },
            {
              label: {
                [Op.or]: filter.grade.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.streams,
        as: 'stream',
        
        where: filter.stream ? {
          [Op.or]: [
            { id: { [Op.in]: filter.stream.split('|').map(term => Utils.uuid(term)) } },
            {
              name_en: {
                [Op.or]: filter.stream.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'exams',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            starts_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    ends_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.starts_atRange) {
                const [start, end] = filter.starts_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    starts_at: {
                    ...where.starts_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    starts_at: {
                    ...where.starts_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ends_atRange) {
                const [start, end] = filter.ends_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.exam_type) {
                where = {
                    ...where,
                exam_type: filter.exam_type,
            };
            }
            
            if (filter.public_results) {
                where = {
                    ...where,
                public_results: filter.public_results,
            };
            }
            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.exams.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'exams',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.exams.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

